#!/usr/bin/ruby
#
#  sosu.rb
#    sosu for ruby
#
#    2014/01/19 V0.10 port to ruby
#

# consts
VER      = "V0.10"

# globals
$vf      = 0          # disp sosu

# local var
smax     = 10000      # max sosu
calc_cnt = 0          # num of calc
nsosu    = 0          # num of sosu


def get_msec()
  dt = Time.now
  msec = (dt.hour*3600+dt.min*60+dt.sec)*1000 + (dt.usec/1000.0).round
  return msec
end

def sosu(st_num, en_num, thd_no)
  cnt    = 0   # num of sosu
  calcnt = 0   # num of calc
  exist  = 0

  puts "# start sosu(#{thd_no}) #{st_num}-#{en_num}"
  for x in 2..en_num
    exist = 0
    for i in 2..x-1
      calcnt += 1
      if (x % i) == 0 then
        exist = 1
        break
      end
    end
    if exist == 0 then
      cnt += 1
      if $vf == 1 then
        print "#{x} "   # disp sosu
      end
    end
  end
  if $vf == 1 then
    print "\n"
  end
  puts "# end   sosu(#{thd_no}) calc=#{calcnt} sosu=#{cnt}"
  return calcnt, cnt
end


#  main
#
# arg check

for i in 0..ARGV.size-1
  if ARGV[i] == "-h" #then
    puts "usage: sosu.rb [-v] [num<" + smax.to_s + ">]"
    exit(1)
  elsif ARGV[i] == "-v" #then
    $vf = 1
  else
    smax = ARGV[i].to_i
  end
end


puts "sosu.rb #{VER} by oga."
puts "sosu start(#{smax})..."

start_ms        = get_msec()
#puts "start = #{start_ms}"
calc_cnt, nsosu = sosu(2, smax, 0)   # st_num, en_num, thread_no
end_ms          = get_msec()
puts "num of sosu = #{nsosu}"
 
result_ms = end_ms - start_ms

#puts "MAX #{smax}: CALC=#{calc_cnt} TIME=" + (result_ms/1000).to_s + " sec"
puts "\nMAX #{smax}: CALC=#{calc_cnt} TIME=#{(result_ms/1000)}.#{(result_ms % 1000)} sec"

if smax == 10000 then
  puts "\nS'Mark99 => " + ((100*1000)/result_ms).to_s
end


